"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ClaimRecord = exports.Action = void 0;
exports.actionFromJSON = actionFromJSON;
exports.actionToJSON = actionToJSON;

var _coin = require("../../../cosmos/base/v1beta1/coin");

var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));

var _helpers = require("@osmonauts/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var Action;
exports.Action = Action;

(function (Action) {
  Action[Action["ActionInitialClaim"] = 0] = "ActionInitialClaim";
  Action[Action["ActionBidNFT"] = 1] = "ActionBidNFT";
  Action[Action["ActionMintNFT"] = 2] = "ActionMintNFT";
  Action[Action["ActionVote"] = 3] = "ActionVote";
  Action[Action["ActionDelegateStake"] = 4] = "ActionDelegateStake";
  Action[Action["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Action || (exports.Action = Action = {}));

function actionFromJSON(object) {
  switch (object) {
    case 0:
    case "ActionInitialClaim":
      return Action.ActionInitialClaim;

    case 1:
    case "ActionBidNFT":
      return Action.ActionBidNFT;

    case 2:
    case "ActionMintNFT":
      return Action.ActionMintNFT;

    case 3:
    case "ActionVote":
      return Action.ActionVote;

    case 4:
    case "ActionDelegateStake":
      return Action.ActionDelegateStake;

    case -1:
    case "UNRECOGNIZED":
    default:
      return Action.UNRECOGNIZED;
  }
}

function actionToJSON(object) {
  switch (object) {
    case Action.ActionInitialClaim:
      return "ActionInitialClaim";

    case Action.ActionBidNFT:
      return "ActionBidNFT";

    case Action.ActionMintNFT:
      return "ActionMintNFT";

    case Action.ActionVote:
      return "ActionVote";

    case Action.ActionDelegateStake:
      return "ActionDelegateStake";

    default:
      return "UNKNOWN";
  }
}

function createBaseClaimRecord() {
  return {
    address: "",
    initialClaimableAmount: [],
    actionCompleted: []
  };
}

var ClaimRecord = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    if (message.address !== "") {
      writer.uint32(10).string(message.address);
    }

    var _iterator = _createForOfIteratorHelper(message.initialClaimableAmount),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;

        _coin.Coin.encode(v, writer.uint32(18).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    writer.uint32(34).fork();

    var _iterator2 = _createForOfIteratorHelper(message.actionCompleted),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _v = _step2.value;
        writer.bool(_v);
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    writer.ldelim();
    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseClaimRecord();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.address = reader.string();
          break;

        case 2:
          message.initialClaimableAmount.push(_coin.Coin.decode(reader, reader.uint32()));
          break;

        case 4:
          if ((tag & 7) === 2) {
            var end2 = reader.uint32() + reader.pos;

            while (reader.pos < end2) {
              message.actionCompleted.push(reader.bool());
            }
          } else {
            message.actionCompleted.push(reader.bool());
          }

          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      address: (0, _helpers.isSet)(object.address) ? String(object.address) : "",
      initialClaimableAmount: Array.isArray(object === null || object === void 0 ? void 0 : object.initialClaimableAmount) ? object.initialClaimableAmount.map(function (e) {
        return _coin.Coin.fromJSON(e);
      }) : [],
      actionCompleted: Array.isArray(object === null || object === void 0 ? void 0 : object.actionCompleted) ? object.actionCompleted.map(function (e) {
        return Boolean(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.address !== undefined && (obj.address = message.address);

    if (message.initialClaimableAmount) {
      obj.initialClaimableAmount = message.initialClaimableAmount.map(function (e) {
        return e ? _coin.Coin.toJSON(e) : undefined;
      });
    } else {
      obj.initialClaimableAmount = [];
    }

    if (message.actionCompleted) {
      obj.actionCompleted = message.actionCompleted.map(function (e) {
        return e;
      });
    } else {
      obj.actionCompleted = [];
    }

    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$address, _object$initialClaima, _object$actionComplet;

    var message = createBaseClaimRecord();
    message.address = (_object$address = object.address) !== null && _object$address !== void 0 ? _object$address : "";
    message.initialClaimableAmount = ((_object$initialClaima = object.initialClaimableAmount) === null || _object$initialClaima === void 0 ? void 0 : _object$initialClaima.map(function (e) {
      return _coin.Coin.fromPartial(e);
    })) || [];
    message.actionCompleted = ((_object$actionComplet = object.actionCompleted) === null || _object$actionComplet === void 0 ? void 0 : _object$actionComplet.map(function (e) {
      return e;
    })) || [];
    return message;
  }
};
exports.ClaimRecord = ClaimRecord;