export const createRPCMsgClient = async ({
  rpc
}) => ({
  cosmos: {
    bank: {
      v1beta1: new (await import("../cosmos/bank/v1beta1/tx.rpc.msg")).MsgClientImpl(rpc)
    },
    distribution: {
      v1beta1: new (await import("../cosmos/distribution/v1beta1/tx.rpc.msg")).MsgClientImpl(rpc)
    },
    gov: {
      v1: new (await import("../cosmos/gov/v1/tx.rpc.msg")).MsgClientImpl(rpc),
      v1beta1: new (await import("../cosmos/gov/v1beta1/tx.rpc.msg")).MsgClientImpl(rpc)
    },
    group: {
      v1: new (await import("../cosmos/group/v1/tx.rpc.msg")).MsgClientImpl(rpc)
    },
    staking: {
      v1beta1: new (await import("../cosmos/staking/v1beta1/tx.rpc.msg")).MsgClientImpl(rpc)
    }
  },
  publicawesome: {
    stargaze: {
      alloc: {
        v1beta1: new (await import("../stargaze/alloc/v1beta1/tx.rpc.msg")).MsgClientImpl(rpc)
      },
      claim: {
        v1beta1: new (await import("../stargaze/claim/v1beta1/tx.rpc.msg")).MsgClientImpl(rpc)
      }
    }
  }
});